<section
  class="l-body l-body--full-width mat-elevation-z0"
  *ngIf="paginator$ | async as paginator"
>
  <header class="page-header">
    <gt-list-title
      i18n-title
      title="Issues"
      [searchHits]="paginator.count"
    ></gt-list-title>
  </header>
  <gt-project-filter-bar></gt-project-filter-bar>

  <div *ngIf="issues$ | async as issues" class="wrapper">
    <table
      mat-table
      [dataSource]="issues$"
      [trackBy]="trackIssues"
      class="mat-elevation-z2"
      [class.fixedLayout]="issues.length === 0"
    >
      <ng-container matColumnDef="actions">
        <th
          mat-header-cell
          [attr.colspan]="displayedColumns.length"
          *matHeaderCellDef
          class="resolved-row"
          class="table-header"
        >
          <ng-container
            *ngIf="
              organizationEnvironments$ | async as organizationEnvironments
            "
          >
            <gt-data-filter-bar
              [dateForm]="dateForm"
              [environmentForm]="environmentForm"
              [searchForm]="form"
              [sortForm]="sortForm"
              [sorts]="sorts"
              [organizationEnvironments]="organizationEnvironments"
              (dateFormSubmission)="onDateFormSubmit($event)"
              (dateFormReset)="dateFormReset()"
              (filterByEnvironment)="filterByEnvironment($event)"
              (searchSubmit)="searchSubmit()"
              (sortByChanged)="sortByChanged($event)"
            ></gt-data-filter-bar>
          </ng-container>
        </th>
      </ng-container>

      <ng-container matColumnDef="select">
        <th
          mat-header-cell
          *matHeaderCellDef
          [class.sticky-header]="(thereAreSelectedIssues$ | async) === true"
        >
          <mat-checkbox
            (change)="toggleSelectAll()"
            [checked]="(areAllSelected$ | async)!"
            [disabled]="issues.length === 0"
            id="selectAll"
          >
          </mat-checkbox>
        </th>
        <td
          mat-cell
          *matCellDef="let row"
          [class.resolved]="row.status === 'resolved'"
          [class.ignored]="row.status === 'ignored'"
          class="checkbox-cell level level--{{ row.level }}"
        >
          <mat-checkbox
            (change)="toggleCheck(row.id)"
            [checked]="row.isSelected"
          >
          </mat-checkbox>
        </td>
      </ng-container>

      <ng-container matColumnDef="title">
        <th
          mat-header-cell
          *matHeaderCellDef
          mat-sort-header
          [class.sticky-header]="(thereAreSelectedIssues$ | async) === true"
        >
          <div class="button-group">
            <button
              id="bulkMarkResolved"
              mat-flat-button
              color="primary"
              (click)="bulkMarkResolved()"
              [disabled]="(thereAreSelectedIssues$ | async) === false"
              i18n
              >Mark as resolved</button
            >
            <button
              mat-stroked-button
              (click)="bulkMarkUnresolved()"
              [disabled]="(thereAreSelectedIssues$ | async) === false"
              i18n
              >Reopen</button
            >
            <button
              mat-stroked-button
              (click)="bulkMarkIgnored()"
              [disabled]="(thereAreSelectedIssues$ | async) === false"
              i18n
              >Ignore</button
            >
          </div>
        </th>
        <td
          mat-cell
          *matCellDef="let element"
          [class.resolved]="element.status === 'resolved'"
          [class.ignored]="element.status === 'ignored'"
          class="title-cell"
        >
          <mat-icon
            *ngIf="element.status === 'ignored'"
            inline="true"
            class="mute-icon"
          >
            volume_off
          </mat-icon>
          <a [routerLink]="element.id" queryParamsHandling="merge">{{
            element.title
          }}</a>
          <div class="other-cell-info mat-caption">
            {{ element.count | i18nPlural : eventCountPluralMapping }}
          </div>
          <div>
            <span
              class="mat-caption"
              *ngIf="(appliedProjectCount$ | async) !== 1"
            >
              {{ element.projectSlug }}
            </span>
            <span class="mat-caption" *ngIf="true">
              <ng-container *ngIf="(appliedProjectCount$ | async) !== 1">
                &mdash;
              </ng-container>
              <time
                [dateTime]="element.firstSeen"
                [title]="element.firstSeen | date : 'medium'"
              >
                {{ element.firstSeen | daysOld }},
              </time>
              seen
              <time
                *ngIf="element.firstSeen !== element.lastSeen"
                [dateTime]="element.lastSeen"
                [title]="element.lastSeen | date : 'medium'"
              >
                {{ element.lastSeen | daysAgo }}
              </time>
            </span>
            <span
              class="mat-caption"
              *ngIf="element.type && element.type === 'csp'"
              ><span
                *ngIf="(appliedProjectCount$ | async) !== 1 && element.type"
              >
                &mdash; </span
              >{{ element.type }} report</span
            >
          </div>
        </td>
      </ng-container>

      <ng-container matColumnDef="bulkProjectSelect">
        <td
          mat-header-cell
          *matHeaderCellDef
          colspan="3"
          class="bulk-project-select__inner"
        >
          <ng-container *ngIf="(showBulkSelectProject$ | async) === true">
            <ng-container
              *ngIf="
                (selectedProjectInfo$ | async | json) === '{}';
                else deselect
              "
              ><span class="bulk-project-select__text"
                >{{ numberOfSelectedIssues$ | async }} issues on this page
                selected.</span
              >
              <button
                id="bulkUpdateProject"
                mat-stroked-button
                color="primary"
                (click)="bulkUpdateProject()"
              >
                <ng-container *ngIf="searchHits$ | async as searchHits"
                  >Select all {{ searchHits }} issues that match this
                  query</ng-container
                >
              </button></ng-container
            ><ng-template #deselect
              ><span class="bulk-project-select__text"
                >All {{ searchHits$ | async }} issues are currently
                selected.</span
              >
              <button
                mat-stroked-button
                color="primary"
                (click)="clearBulkProjectUpdate()"
              >
                Undo
              </button></ng-template
            ></ng-container
          >
        </td>
      </ng-container>

      <ng-container matColumnDef="events">
        <th
          mat-header-cell
          *matHeaderCellDef
          mat-sort-header
          class="status-header-cell sticky-header"
          [class.sticky-header]="(thereAreSelectedIssues$ | async) === true"
        >
          Events
        </th>
        <td
          mat-cell
          *matCellDef="let element"
          [class.resolved]="element.status === 'resolved'"
          [class.ignored]="element.status === 'ignored'"
          class="event-cell mat-body-1"
        >
          <p>{{ element.count }}</p>
        </td>
      </ng-container>
      <ng-container matColumnDef="pagination">
        <td
          mat-footer-cell
          *matFooterCellDef
          [attr.colspan]="displayedColumns.length"
        >
          <gt-list-footer [paginator]="paginator"> </gt-list-footer>
        </td>
      </ng-container>
      <tr mat-header-row *matHeaderRowDef="['actions']"></tr>
      <tr
        mat-header-row
        class="overlay"
        *matHeaderRowDef="displayedColumns"
        [class.u-hidden]="issues.length === 0"
      ></tr>
      <tr
        mat-header-row
        *matHeaderRowDef="['bulkProjectSelect']"
        [class.bulk-project-select__hide]="
          (showBulkSelectProject$ | async) === false
        "
      ></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
      <tr class="mat-row" *matNoDataRow>
        <td
          class="mat-cell zero-states-cell"
          [attr.colspan]="displayedColumns.length"
        >
          <gt-issue-zero-states
            *ngIf="paginator.initialLoadComplete"
          ></gt-issue-zero-states>
        </td>
      </tr>
      <tr
        mat-footer-row
        class="pagination-row"
        *matFooterRowDef="['pagination']"
      ></tr>
    </table>
  </div>
</section>
